package org.jeecg.modules.third.controller;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.third.entity.ThirdConfigAdvertiser;
import org.jeecg.modules.third.server.IThirdConfigAdvertiserService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 对外配置关联广告主
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-08-14
 */
@Slf4j
@Api(tags = "对外配置关联广告主")
@RestController
@RequestMapping("/n/thirtConfigAdvertiser")
public class ThirdConfigAdvertiserController {
    @Autowired
    private IThirdConfigAdvertiserService thirtConfigAdvertiserService;

    /**
     * 分页列表查询
     *
     * @param thirtConfigAdvertiser
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @ApiOperation(value = "对外配置关联广告主-分页列表查询", notes = "对外配置关联广告主-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<ThirdConfigAdvertiser>> queryPageList(ThirdConfigAdvertiser thirtConfigAdvertiser,
                                                              @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                              @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                              HttpServletRequest req) {
        Result<IPage<ThirdConfigAdvertiser>> result = new Result<>();
        QueryWrapper<ThirdConfigAdvertiser> queryWrapper = QueryGenerator.initQueryWrapper(thirtConfigAdvertiser, req.getParameterMap());
        Page<ThirdConfigAdvertiser> page = new Page<ThirdConfigAdvertiser>(pageNo, pageSize);
        IPage<ThirdConfigAdvertiser> pageList = thirtConfigAdvertiserService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param thirtConfigAdvertiser
     * @return
     */
    @ApiOperation(value = "对外配置关联广告主-添加", notes = "对外配置关联广告主-添加")
    @PostMapping(value = "/add")
    public Result<ThirdConfigAdvertiser> add(@RequestBody ThirdConfigAdvertiser thirtConfigAdvertiser) {
        Result<ThirdConfigAdvertiser> result = new Result<>();
        try {
            thirtConfigAdvertiserService.save(thirtConfigAdvertiser);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param thirtConfigAdvertiser
     * @return
     */
    @ApiOperation(value = "对外配置关联广告主-编辑", notes = "对外配置关联广告主-编辑")
    @PutMapping(value = "/edit")
    public Result<ThirdConfigAdvertiser> edit(@RequestBody ThirdConfigAdvertiser thirtConfigAdvertiser) {
        Result<ThirdConfigAdvertiser> result = new Result<ThirdConfigAdvertiser>();
        ThirdConfigAdvertiser thirtConfigAdvertiserEntity = thirtConfigAdvertiserService.getById(thirtConfigAdvertiser.getId());
        if (thirtConfigAdvertiserEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = thirtConfigAdvertiserService.updateById(thirtConfigAdvertiser);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "对外配置关联广告主-通过id删除", notes = "对外配置关联广告主-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            thirtConfigAdvertiserService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @ApiOperation(value = "对外配置关联广告主-批量删除", notes = "对外配置关联广告主-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<ThirdConfigAdvertiser> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<ThirdConfigAdvertiser> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.thirtConfigAdvertiserService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "对外配置关联广告主-通过id查询", notes = "对外配置关联广告主-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<ThirdConfigAdvertiser> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<ThirdConfigAdvertiser> result = new Result<>();
        ThirdConfigAdvertiser thirtConfigAdvertiser = thirtConfigAdvertiserService.getById(id);
        if (thirtConfigAdvertiser == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(thirtConfigAdvertiser);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<ThirdConfigAdvertiser> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                ThirdConfigAdvertiser thirtConfigAdvertiser = JSON.parseObject(deString, ThirdConfigAdvertiser.class);
                queryWrapper = QueryGenerator.initQueryWrapper(thirtConfigAdvertiser, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<ThirdConfigAdvertiser> pageList = thirtConfigAdvertiserService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "对外配置关联广告主列表");
        mv.addObject(NormalExcelConstants.CLASS, ThirdConfigAdvertiser.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("对外配置关联广告主列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<ThirdConfigAdvertiser> listThirtConfigAdvertisers = ExcelImportUtil.importExcel(file.getInputStream(), ThirdConfigAdvertiser.class, params);
                thirtConfigAdvertiserService.saveBatch(listThirtConfigAdvertisers);
                return Result.ok("文件导入成功！数据行数:" + listThirtConfigAdvertisers.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
